Scriptname SLPGNDeflateOnDeath extends Quest

sr_inflateConfig Property config Auto
sr_inflateQuest Property inflater Auto

Actor Property PlayerRef Auto
Armor Property VagLeak Auto


; This is called on every "death" and it checks how full the "tank" is, and if it is full, deflate.
Function DeflateIfFull()
    float maxamount = config.maxInflation * 1.2
    float tolerance = config.maxInflation * 0.1 ; This is because I noticed an issue where FHU had problems getting up to the true full amount, so we add a tolerance percentage to make up for it.

    ; Turned out checking just one pool and comparing it to the max amount caused it to never work. Adding the two "pools" together, though makes this work.
    ; The "+1.0" is due to how FHU works. It starts off at 1.0, so we add 1.0 to it to get the true full total.
    float totalCum = StorageUtil.GetFloatValue(PlayerRef, inflater.CUM_VAGINAL) + StorageUtil.GetFloatValue(PlayerRef, inflater.CUM_ANAL) + 1.0
    
    If(totalCum >= (maxamount - tolerance)) ; Greater than or equal to the max amount.
        DeathlyDeflate()
    EndIf
EndFunction


Function DeathlyDeflate()
    String pool = inflater.CUM_VAGINAL ; I'm not sure how to do both at the same time, so vaginal only. 
    float cum = StorageUtil.GetFloatValue(PlayerRef, pool)
    Utility.wait(2.0) ; wait a few seconds because happening instantly seems a bit odd to me. 
    
    PartialRes()

    float currentInf = inflater.GetInflation(PlayerRef)
    float originalCum = cum
    float originalInf = currentInf
        
    PlayerRef.AddItem(VagLeak, 1, true)
    PlayerRef.EquipItem(VagLeak, false, true)

    While (cum > 0.02 && currentInf > inflater.GetOriginalScale(PlayerRef))
        currentInf -= 0.1
        cum -= 0.1
        NetImmerse.SetNodeScale(PlayerRef, "NPC Belly", currentInf, false)
        Utility.Wait(0.3)
    EndWhile

    If(cum < 0.02)
        cum = 0.0
    EndIf

    float diff = originalCum - cum
    currentInf = originalInf - diff

    If(currentInf < inflater.GetOriginalScale(PlayerRef))
        currentInf = inflater.GetOriginalScale(PlayerRef)
        StorageUtil.FormListRemove(inflater, inflater.INFLATED_ACTORS, PlayerRef, true)
    EndIf

    NetImmerse.SetNodeScale(PlayerRef, "NPC Belly", currentInf, false)
    StorageUtil.SetFloatValue(PlayerRef, inflater.INFLATION_AMOUNT, currentInf)
    StorageUtil.SetFloatValue(PlayerRef, pool, cum)
    Utility.Wait(0.1)
    PlayerRef.RemoveItem(VagLeak, 1, true, None)
    Die()
EndFunction


Function PartialRes() ; Partial because deflation won't work on a dead actor.
    PlayerRef.ResetHealthAndLimbs()
    PlayerRef.SetUnconscious(true)
    Debug.SetGodMode(true) ; Set god mode until I can figure out how to make the NPCs ignore the player character so the PC doesn't die.
EndFunction


Function Die()
    Debug.SetGodMode(false)
    PlayerRef.KillSilent()
endFunction


;Check if the things are actually something, and if not set them to what they should be to make things work.
Function InitializeParameters()
    If(inflater == NONE)
        inflater = Game.GetFormFromFile(0xD63, "sr_FillHerUp.esp") as sr_inflateQuest
    EndIf

    If(config == NONE)
        config = Game.GetFormFromFile(0x1D8C,"sr_FillHerUp.esp") as sr_inflateConfig
    EndIf

    log("FHU content initialized.") 
EndFunction


Function log(String argString)
    Debug.Trace("SLPGN Deflation: " + Utility.GetCurrentRealTime()+ " -- " + argString )    
EndFunction
